/* JdbcApplet (c) Stefan Rauch 1999          */
/* Applet, das den Umgang mit dem JDBC zeigt */


import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.sql.*;


public class JdbcApplet extends Applet {

  BorderLayout layout = new BorderLayout();
  TextArea outputArea = new TextArea();
  TextField inputField = new TextField();
  Panel p;

/* Erstellen der Buttons, die den Inhalt der benannten Tabellen komplett ausgeben */
  Button qu1 = new Button("Professoren");
  Button qu2 = new Button("Assistenten");
  Button qu3 = new Button("Studenten");
  Button qu4 = new Button("Vorlesungen");
  Button qu5 = new Button("hoeren");
  Button qu6 = new Button("voraussetzen");
  Button qu7 = new Button("pruefen");
  Button qu8 = new Button("select * from tab");

/* Verbindungsobjekt um die Verbindung zum DBMS aufzubauen */
  Connection con;

/* Statement-Objekt zur Kommunikation mit DBMS */
  Statement stmt;


  public JdbcApplet() {
  }

/* Das Applet initialisieren */

  public void init() {
    try {
      this.setLayout(layout);
      this.setSize(700,400);
      inputField.setBackground(Color.gray);
      inputField.setFont(new Font("Serif",1,14));

/* ActionListener fuer das Eingabefeld         */
/* gibt den Text an Methode execQuery() weiter */
      inputField.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          String q = inputField.getText();
          execQuery(q);
        }
      });
      outputArea.setBackground(Color.white);
      outputArea.setEditable(false);
      outputArea.setFont(new Font("Monospaced",1,14));

/* ActionListener fuer jeweiligen Button      */
/* gibt Abfrage an Methode execQuery() weiter */
      qu1.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          execQuery("select persnr,name,rang,raum," +
                    "to_char(gebdatum,'dd:mm:YYYY') as Geburtsdatum from Professoren");
        }
      });
      qu2.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          execQuery("select persnr, name, fachgebiet, boss," +
                    "to_char(gebdatum,'dd:mm:YYYY') as Geburtsdatum from Assistenten");
        }
      });
      qu3.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          execQuery("select matrnr, name, semester," +
                    "to_char(gebdatum,'dd:mm:YYYY') as Geburtsdatum from Studenten");
        }
      });
      qu4.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          execQuery("select * from Vorlesungen");
        }
      });
      qu5.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          execQuery("select * from hoeren");
        }
      });
      qu6.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          execQuery("select * from voraussetzen");
        }
      });
      qu7.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          execQuery("select * from pruefen");
        }
      });
      qu8.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          execQuery("select * from tab");
        }
      });

/* Hinzufuegen und Anordnen der einzelnen Elemente des Applets */
      this.add(outputArea, BorderLayout.CENTER);
      this.add(inputField, BorderLayout.NORTH);
      this.add(p= new Panel(new GridLayout(8,1)), BorderLayout.WEST);
      p.add(qu1);
      p.add(qu2);
      p.add(qu3);
      p.add(qu4);
      p.add(qu5);
      p.add(qu6);
      p.add(qu7);
      p.add(qu8);
    }
    catch (Exception e) {
      e.printStackTrace();
    }

/* Verbindungsaufbau mit dem DBMS */
    String url    = "jdbc:odbc:dbserv.dsn";
    String user   = "Erika";
    String passwd = "Mustermann";

/* JDBC-ODBC Brueckentreiber wird genutzt und vom DriverManager registriert */
    try {
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    }
    catch(java.lang.ClassNotFoundException ex) {
      System.err.print("ClassNotFoundException: ");
      System.err.println(ex.getMessage());
    }

/* Verbindung zum DBMS wird geoeffnet */
    try {
      con = DriverManager.getConnection(url, user, passwd);
    }
    catch(SQLException ex) {
      outputArea.setText("SQLException: " + ex.getMessage());
    }
  }


/* Methode, die die jeweiligen SQL-Querys an das DBMS weiterleitet und die */
/* in einem ResultSet empfangenen Ergebnisse in der TextArea darstellt     */

  void execQuery(String query) {

    try {

/* Fuer jede Abfrage muss ein Statement-Objekt instantiiert werden */
      stmt = con.createStatement();

/* Ausfuehren der Abfrage und Speichern der Ergebnisse im ResultSet rs */
      ResultSet rs = stmt.executeQuery(query);	

/* z := Anzahl der Spalten des Ergebnisses */
      int z = rs.getMetaData().getColumnCount();
      outputArea.setText("\n");
      outputArea.setVisible(false);

/* Fuer jede Spalte wird zunaechst der Spaltenname formatiert ausgegeben */
      for (int i=1;i<=z;i++) {
        String lab=rs.getMetaData().getColumnLabel(i);
        outputArea.append(lab);
        int y = rs.getMetaData().getColumnDisplaySize(i)+4;
        for (int j=0;j<(y-lab.length());j++)
          outputArea.append(" ");
        }
        outputArea.append("\n");

/* Der Inhalt der Ergebnismenge wird zeilenweise formatiert in der TextArea ausgegeben */
        String arg;
        while(rs.next()) {
          outputArea.append("\n");
          for (int i=1;i<=z;i++) {
            arg=rs.getString(i);
            int len;
            if (arg != null) {
              len=arg.length();
              outputArea.append(arg);
            }
            else {
              len=4;
              outputArea.append("null");
            }
            int y = rs.getMetaData().getColumnDisplaySize(i)+4;
            for (int j=0;j<(y-len);j++)
              outputArea.append(" ");
          }
        }

        outputArea.setVisible(true);
        stmt.close();

/* Abfangen von etwaigen SQL-Fehlermeldungen und Ausgabe derer in der TextArea */
      }catch(SQLException ex) {
        outputArea.setText("SQLException: " + ex.getMessage());
      }

  }

}

