/* ShowJdbc.java (c) Stefan Rauch 1999 */

import java.sql.*;                               // Import der SQL-Klassen

public class ShowJdbc {

  public static void main(String args[]) {

    String url = "jdbc:odbc:dbserv.dsn";          // Treiber-url f. Verbindung
    Connection con;                              // Verbindungs-Objekt
    Statement stmt;                              // Instanz der Verbindung
                                                 // sendet query und liefert 
                                                 // Ergebnis (ResultSet)
    String user   = "Erika";
    String passwd = "Mustermann";
    String query  = "select * from Professoren";

    try {                                        // Laden des jdbc-odbc-Brueckentreiber
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    }catch(java.lang.ClassNotFoundException e) {
      System.err.print("ClassNotFoundException: ");
      System.err.println(e.getMessage());
    }

    try {                                        
      con = DriverManager.getConnection(url, user, passwd); // Erst. der Verbindung
      stmt = con.createStatement();              // Instantiierung des Statement
      ResultSet rs = stmt.executeQuery(query);   // Ergebnis in ResultSet

      System.out.println("Ausgabe der Professoren mit jeweiligem Rang: \n");
      
      while(rs.next()) {                         // Zeilenweise durch 
        System.out.print("Der Professor ");      // Ergebnismenge laufen
        System.out.print(rs.getString("Name"));  // dabei Namen und Rang 
        System.out.print(" hat den Rang ");      // formatiert ausgeben
        System.out.println(rs.getString("Rang"));
      }
      stmt.close();                              // Schliessen des Statements
      con.close();                               // Schliessen der Verbindung

    }catch(SQLException ex) {
      System.err.println("SQLException: " + ex.getMessage());
    }
  }
}
